//  Copyright (C) SystemTools Software Inc. All Rights Reserved.
//
//
//  The STRCM utility is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
//  USA.
//
//  Further information on this software can be obtained from:
//
//  http://www.systemtools.com/strcm_frame.htm
//  
//  Additional contact and support information is available at this site.

// dialog.cpp : implementation file
//

#include "stdafx.h"
#include "strcm.h"
#include "dialog.h"
#include "include.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEula dialog


CEula::CEula(CWnd* pParent /*=NULL*/)
	: CDialog(CEula::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEula)
	m_Accept = FALSE;
	m_Eula = _T("");
	//}}AFX_DATA_INIT
}


void CEula::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEula)
	DDX_Check(pDX, IDC_ACCEPT, m_Accept);
	DDX_Text(pDX, IDC_EULA, m_Eula);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEula, CDialog)
	//{{AFX_MSG_MAP(CEula)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEula message handlers
// CInstall dialog


CInstall::CInstall(CWnd* pParent /*=NULL*/)
	: CDialog(CInstall::IDD, pParent)
{
	//{{AFX_DATA_INIT(CInstall)
	m_Source = _T("");
	m_Target = _T("");
	m_Type = _T("");
	m_Dest = _T("");
	m_InstallService = FALSE;
	m_AutoStart = FALSE;
	m_DisplayName = _T("");
	m_ExeName = _T("");
	m_Password = _T("");
	m_Password2 = _T("");
	//}}AFX_DATA_INIT
}


void CInstall::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CInstall)
	DDX_Control(pDX, IDC_SERVICE_NAME, m_cServiceName);
	DDX_Text(pDX, IDC_SOURCE, m_Source);
	DDV_MaxChars(pDX, m_Source, 255);
	DDX_Text(pDX, IDC_TARGET, m_Target);
	DDX_Text(pDX, IDC_TYPE, m_Type);
	DDX_Text(pDX, IDC_DEST, m_Dest);
	DDX_Check(pDX, IDC_INSTALL_SERVICE, m_InstallService);
	DDX_Check(pDX, IDC_AUTOSTART, m_AutoStart);
	DDX_Text(pDX, IDC_DISPLAY_NAME, m_DisplayName);
	DDV_MaxChars(pDX, m_DisplayName, 30);
	DDX_Text(pDX, IDC_EXE_NAME, m_ExeName);
	DDV_MaxChars(pDX, m_ExeName, 30);
	DDX_Text(pDX, IDC_PASSWORD, m_Password);
	DDX_Text(pDX, IDC_PASSWORD2, m_Password2);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CInstall, CDialog)
	//{{AFX_MSG_MAP(CInstall)
	ON_BN_CLICKED(IDC_SOURCE_FIND, OnSourceFind)
	ON_BN_CLICKED(IDC_INSTALL_SERVICE, OnInstallService)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInstall message handlers

void CInstall::OnSourceFind() 
{
	AfxMessageBox(_T("Not implemented at this time"), MB_OK);	
}

BOOL CInstall::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	if (m_ServiceName.GetLength() == 0)
		return TRUE;

	CString Service = "";
	m_ServiceName += ";";
	for (int i=0; i < m_ServiceName.GetLength(); i++)
	{
		if (m_ServiceName[i] != ';')
			Service += m_ServiceName[i];
		else
		{
			m_cServiceName.AddString(Service);
			Service = "";
		}
	}
	m_cServiceName.SetCurSel(0);
	SetServiceOptions();

	if (m_Type.CompareNoCase(_T("VNC")) == 0)
	{
		((CEdit*) GetDlgItem(IDC_PASSWORD))->LimitText(MAX_VNC_PWD_LEN + 4);
		((CEdit*) GetDlgItem(IDC_PASSWORD2))->LimitText(MAX_VNC_PWD_LEN + 4);
	}
	return TRUE;
}

void CInstall::OnInstallService() 
{
	UpdateData(TRUE);
	SetServiceOptions();
}

void CInstall::SetServiceOptions()
{
	((CWnd*) GetDlgItem(IDC_SERVICE_NAME))->EnableWindow(m_InstallService);
	((CWnd*) GetDlgItem(IDC_AUTOSTART))->EnableWindow(m_InstallService);
	((CWnd*) GetDlgItem(IDC_DISPLAY_NAME))->EnableWindow(m_InstallService);
	((CWnd*) GetDlgItem(IDC_EXE_NAME))->EnableWindow(m_InstallService);
}

void CInstall::OnOK() 
{
	UpdateData(TRUE);

	if (m_Password.GetLength() > 0)
	{
		if (m_Password != m_Password2)
		{
			MessageBeep(MB_ICONSTOP);
			AfxMessageBox(IDS_PWDS_DIFFERENT, MB_ICONSTOP | MB_OK);
			m_Password = "";
			m_Password2 = "";
			UpdateData(FALSE);
			return;
		}
	}
	int i = m_cServiceName.GetCurSel();
	m_cServiceName.GetLBText(i, m_ServiceName);

	CDialog::OnOK();
}

/////////////////////////////////////////////////////////////////////////////
// CVNCOptions dialog


CVNCOptions::CVNCOptions(CWnd* pParent /*=NULL*/)
	: CDialog(CVNCOptions::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVNCOptions)
	m_Pwd = _T("");
	m_Pwd2 = _T("");
	m_PollConsoleOnly = FALSE;
	m_PollEventOnly = FALSE;
	m_PollForeground = FALSE;
	m_PollFullScreen = FALSE;
	m_PollUnderCursor = FALSE;
	m_SocketConnect = FALSE;
	m_AutoPortSelect = FALSE;
	m_DisableLocalKP = FALSE;
	m_DisableRemoteKP = FALSE;
	m_PortNumber = 0;
	//}}AFX_DATA_INIT
}


void CVNCOptions::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVNCOptions)
	DDX_Text(pDX, IDC_PWD, m_Pwd);
	DDX_Text(pDX, IDC_PWD2, m_Pwd2);
	DDX_Check(pDX, POLL_CONSOLE_ONLY, m_PollConsoleOnly);
	DDX_Check(pDX, POLL_EVENT_ONLY, m_PollEventOnly);
	DDX_Check(pDX, POLL_FOREGROUND, m_PollForeground);
	DDX_Check(pDX, POLL_FULL_SCREEN, m_PollFullScreen);
	DDX_Check(pDX, POLL_UNDER_CURSOR, m_PollUnderCursor);
	DDX_Check(pDX, IDC_SOCKET_CONNECT, m_SocketConnect);
	DDX_Check(pDX, IDC_AUTO_PORT_SELECT, m_AutoPortSelect);
	DDX_Check(pDX, IDC_DISABLE_LOCAL_KP, m_DisableLocalKP);
	DDX_Check(pDX, IDC_DISABLE_REMOTE_KP, m_DisableRemoteKP);
	DDX_Text(pDX, IDC_PORT_NUMBER, m_PortNumber);
	DDV_MinMaxDWord(pDX, m_PortNumber, 0, 9999);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CVNCOptions, CDialog)
	//{{AFX_MSG_MAP(CVNCOptions)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVNCOptions message handlers

void CVNCOptions::OnOK() 
{

	UpdateData(TRUE);

	if (m_Pwd.GetLength() > 0)
	{
		if (m_Pwd != m_Pwd2)
		{
			MessageBeep(MB_ICONSTOP);
			AfxMessageBox(IDS_PWDS_DIFFERENT, MB_ICONSTOP | MB_OK);
			m_Pwd = "";
			m_Pwd2 = "";
			UpdateData(FALSE);
			return;
		}
	}
	
	CDialog::OnOK();
}
