// strcm.h : main header file for the STRCM application
//

#if !defined(AFX_STRCM_H__35BD8526_4A54_4935_82E5_0849B45CF5D1__INCLUDED_)
#define AFX_STRCM_H__35BD8526_4A54_4935_82E5_0849B45CF5D1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols

/////////////////////////////////////////////////////////////////////////////
// CStrcmApp:
// See strcm.cpp for the implementation of this class
//

class CStrcmApp : public CWinApp
{
public:
	CStrcmApp();
	BOOL GetForceX64Setting(LPCTSTR CmdFile);
	REGSAM GetRegAccessRights(REGSAM Default, BOOL ForceX64);
	void RemoteViewer(LPCTSTR CmdFile, LPCTSTR Host, CWnd* wnd);
	CString GetSetting(LPCTSTR CmdFile, LPCTSTR Section, LPCTSTR Setting);
	void ReportError(LPCTSTR ErrorMsg);
	CString LookupError(DWORD Err);
	CString GetCurrentDir();
	BOOL CheckIfExists(LPCTSTR File);
	BOOL RemoteInstall(LPCTSTR CmdFile, LPCTSTR Host, CWnd* wnd);
	void RemoteUnInstall(LPCTSTR CmdFile, LPCTSTR Host, CWnd* wnd);
	void DeleteVNCRegistry(LPCTSTR CmdFile, HKEY hKey, LPCTSTR Host);
	CString StopServices(LPCTSTR ServiceList, LPCTSTR Host, CWnd* wnd);
	CString StartServices(LPCTSTR ServiceList, LPCTSTR Host, CWnd* wnd);
	void StartServiceOperation(LPCTSTR CmdFile, LPCTSTR Host, CWnd* wnd);
	void StopServiceOperation(LPCTSTR CmdFile, LPCTSTR Host, CWnd* wnd);
	void SetVncOptions(LPCTSTR CmdFile, LPCTSTR Host, LPCTSTR Pwd, BOOL ShowDialog);
	void SetOptions(LPCTSTR CmdFile, LPCTSTR Host, CWnd* wnd);
	int GetSettingInt(LPCTSTR CmdFile, LPCTSTR Section, LPCTSTR Setting, int Default);
	void SetSettingInt(LPCTSTR CmdFile, LPCTSTR Section, LPCTSTR Setting, int Value);
	void DisplayProgressMsg(CWnd* wnd, LPCTSTR Msg);

	static UINT GumbyThread (LPVOID param);
	
	typedef struct GUMBYSTRUCT
	{
		CStrcmApp*	m_App;
		//CStrcmDlg*	m_AppDlg;
		HANDLE		m_hProcess; 
		HANDLE		m_hThread;
		CWnd*		m_wnd;
		CString		m_ServiceName;
		CString		m_Host;
		CString		m_ConfigFile;
		BOOL		m_UnInstallService;
	} GUMBYSTRUCT;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CStrcmApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CStrcmApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_STRCM_H__35BD8526_4A54_4935_82E5_0849B45CF5D1__INCLUDED_)
